# Ingestion

## Authenticating

To authenticate to the Ingestion API, you need an API key with the `ingestion` scope. You can read more about [generating and using API keys here](/umbraco-compose/getting-started/access-control.md).

## Ingesting data

There are two ways to use the Ingestion API to store your content in Compose:

* If your source application supports webhooks, then you can use a managed [Ingestion Function](/umbraco-compose/apis/ingestion/functions.md) to transform their payload into a format that Compose understands.
* If you are creating a custom integration to Compose, you can use the standard [RESTful Ingestion](/umbraco-compose/apis/ingestion/restful-ingestion.md) endpoint.

Regardless of which Ingestion method your applications use, the [same structure](/umbraco-compose/apis/ingestion/ingestion-structure.md) should be supplied to Compose.

## Prerequisites

In addition to an API key, to ingest data into your Compose project, you also need an [Environment](/umbraco-compose/content-orchestration/environments.md) with a [Collection](/umbraco-compose/content-orchestration/collections.md).

## API Documentation

Check out the [Ingestion API Documentation](https://apidocs.umbracocompose.com/?api=ingestion-api) for an overview and examples on how to make calls.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.umbraco.com/umbraco-compose/apis/ingestion.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
